﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Threading;
using System.Windows.Threading;
using System.Diagnostics;
using StreamBase.SB;
using StreamBase.SB.Client;
using StreamBase.DataCache;

namespace DataCacheBrowser
{
    /// <summary>
    /// Interaction logic for Window2.xaml
    /// </summary>
    public partial class App : Application
    {
        public App()
        {
        }

        [STAThread]
        public static void Main()
        {
            // Create new instance of application subclass
            App app = new App();

            // Code to register events and set properties that were
            // defined in XAML in the application definition
            app.InitializeComponent();

            // Start running the application
            app.Run();
        }

        void App_DispatcherUnhandledException(object sender, DispatcherUnhandledExceptionEventArgs e)
        {
            // Process unhandled exception
            Trace.WriteLine("Unhandled exception: " + e.Exception.ToString());

            // Prevent default unhandled exception processing
            e.Handled = true;
        }

        void AppStartup(object sender, StartupEventArgs e)
        {
            // Trace.Listeners.Add(new TextWriterTraceListener("myfile.log"));
            // Trace.AutoFlush = true;

            // Initialize client manager
            if (e.Args.Length >= 1)
                SbClientManager.GetSbClientManager().SetSBURI(e.Args[0]);
            else
                SbClientManager.GetSbClientManager().SetSBURI(StreamBaseURI.DEFAULT_URI.ToString());

            // Let MainWindow initialize itself
            MainWindow window = new MainWindow();
            window.Show();
        }

        void AppShutdown(object sender, ExitEventArgs e)
        {
            SbClientManager.GetSbClientManager().Shutdown();
        }
    }
}
