﻿using System;
using System.Diagnostics;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using StreamBase.SB;
using StreamBase.SB.Client;
using Microsoft.Windows.Controls;
using AvalonDock;
using StreamBase.DataCache;

namespace DataCacheBrowser
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    /// 

    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            SbClientManager.GetSbClientManager().Changed += SbClientChangeHandler;
            updateContainers();
        }

        delegate void updateContainersDel();
        public void SbClientChangeHandler(object sender, EventArgs e)
        {
            this.Dispatcher.BeginInvoke( new updateContainersDel( updateContainers ), null );
        }

        private void updateContainers()
        {
            string[] modules = DataCacheConstants.getDataCaches();
            this.Views.Items.Clear();
            if (modules == null || modules.Length == 0)
            {
                return;
            }
            for (int i = 0; i < modules.Length; i++)
            {
                MenuItem mi = new MenuItem();
                mi.Header = modules[i];
                mi.Click += NewDocument;
                this.Views.Items.Add(mi);
            }
        }

        public void Exit(object sender, EventArgs e)
        {
            Application.Current.Shutdown(0);
        }
        
        public void NewDocument( object sender, EventArgs e ) {
            GenericView t = new GenericView(((MenuItem)sender).Header.ToString());
            DockManager.Show(t);
        }
    }
}
