﻿using System.Text;
using StreamBase.SB;

namespace StreamBase.DataCache
{
    public class CacheUpdate
    {
        public StreamBase.SB.Tuple data { get; set; }
        public string key { get; set; }
        public long priority { get; set; }
        public bool isDel { get; set; }

        // Helper for more generic purposes - not generally recommended
        public object this[string idx]
        {
            get
            {
                if (!data.GetSchema().HasField(idx))
                    return null;

                Schema.Field f = data.GetSchema().GetField(idx);
                if (f.GetDataType() == DataType.TUPLE)
                {
                    return data.GetField(idx).ToString();
                }
                else if (f.GetDataType() == DataType.LIST)
                {
                    StringBuilder sb = new StringBuilder("[");
                    foreach (object s in data.GetList(idx))
                    {
                        if (sb.Length > 1)
                            sb.Append("],[");
                        sb.Append(s);
                    }
                    sb.Append("]");
                    return sb.ToString();
                }
                else
                {
                    return data.GetField(idx);
                }
            }
        }
    }
}
