﻿using System;
using System.Collections.Generic;
using StreamBase.SB;

namespace StreamBase.DataCache
{
    // Event delegate handler for the status (connected, disconnected, new containers) change
    // NOTE: Nothing is sent in EventArgs. Poll the sender.
    public delegate void ChangedStatusHandler(object sender, EventArgs e);


    // Public interface for the client
    public interface ISbClient
    {
        void SetSBURI(String u);
        string[] GetContainers();
        bool GetConnected();
        void Shutdown();
        HashSet<StreamProperties> GetInputStreams();
        HashSet<StreamProperties> GetOutputStreams();
        bool EnqueueTuple(String stream, StreamBase.SB.Tuple data);
        void UnsubscribeToStream(String stream, IStreamConsumer cons);
        void SubscribeToStream(String streamName, IStreamConsumer cons);
        void Enqueue(string streamName, StreamBase.SB.Tuple data);

        event ChangedStatusHandler Changed;
    }
}
