package com.streambase.contrib.datacache.gui;

import org.slf4j.LoggerFactory;

import com.streambase.contrib.datacache.gui.swing.DataCacheSwingMain;
import com.streambase.sb.util.Version;

public class SharedUtilities {

	public static void initializeServerConnectivity(String[] args) {
		// initialize the streambase logger immediately, in case the user needs to check their project build path
		try {
			LoggerFactory.getLogger(DataCacheSwingMain.class);
		} catch (NoClassDefFoundError e) {
			// note: this applies for all versions prior to 6.6, actually
			if (Version.VERSION.startsWith("6.5")) {
				System.err.println("");
				System.err.println("Logger not available: under Studio 6.5 please see README.txt:Limitations for details");
				System.exit(-1);
			}
			throw e;
		}
		// and now initialize a connection to the server
		com.streambase.contrib.datacache.DataCacheStreamBaseClient.initClient(args);
	}
}
