package com.streambase.contrib.datacache.gui.swing;

import java.awt.BorderLayout;
import java.text.NumberFormat;

import javax.swing.table.*;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;


@SuppressWarnings("serial")
public class DataCacheTable extends JPanel {
	
	class NumberRenderer extends DefaultTableCellRenderer {
		NumberFormat formatter;
	    public NumberRenderer() { super(); }

	    public void setValue(Object value) {
	        if (formatter==null) {
	            formatter = NumberFormat.getNumberInstance();
	        }
	        setText((value == null) ? "" : formatter.format(value));
	    }
	}
	
	DataCacheTable( String path ) {
		
		// Create the table
		JTable jt = new JTable();
		jt.setAutoCreateRowSorter(true);

		// Set up the table model - this is all you need to know to hook it in to arbitrary module paths!
		CacheTableModel ctm = new CacheTableModel( path );
		jt.setModel( ctm );
		
		// Setup class for formatting numbers
		jt.setDefaultRenderer( Double.class, new NumberRenderer() );
		
		JScrollPane jsp = new JScrollPane( jt );
		this.setLayout( new BorderLayout() );
		this.add( jsp );
		
		this.setVisible(true);
	}
}
